#!/usr/bin/perl

# Trivial Gallery v1.0.0
# by Ethan S. Miller (ethan@k8gu.com)
# 23 October 2008
#
# See README for operating instructions
# See LICENSE for license

# Set thumbnail size
$thumbsize = "200x150";
# Set table cell width
$width = "250";
# Set number of columns in gallery table
$columns = 3;

# Change the rest at your own risk

@albums = `ls -d root/*/`;

# FMI is the "master index" (root/index.html)
open(FMI,">","root/index.html");

printf(FMI "<html>\n<head><title>trivial gallery root</title></head>\n<body bgcolor=black fgcolor=white link=white vlink=white>\n<center>\n<table border=0 cellspacing=0 width=80%%>\n<tr><td bgcolor=#111111 align=left><font face=\"Arial\" size=2 color=white>root /</font></td></tr></table>\n");

printf(FMI "</table><table border=0 cellspacing=4 width=80%%>\n");

foreach $album (@albums) {
    $album =~ s/[\n\r]//gs;
    @pics = `ls $album*.jpg`;
#   FGI is the "album index" (root/album/index.html)
    open(FGI,">",sprintf("%sindex.html",$album));

    @hl = `ls $album/*.h`;
    $highlight = @hl[0];
    $highlight =~ s/[\n\r]//gs;
    $desc = `cat $highlight`;
    $desc =~ s/[\n\r]//gs;
    $highlight =~ s/(\.h)/_thumb.jpg/gs;
    @hlfields = split/\//,$highlight;

    printf(FMI "<tr><td width=%s><a href=\"",$width);
    for ($k = 1; $k < (@hlfields-1); $k++) {
	if (@hlfields[$k] ne "") {
	    printf(FMI "%s/",@hlfields[$k]);
	}
    }
    printf(FMI "index.html\"><img src=\"");

    for ($k = 1; $k < (@hlfields+0); $k++) {
	if (@hlfields[$k] ne "") {
	    printf(FMI "%s",@hlfields[$k]);
	    if ($k != (@hlfields-1)) {
		printf(FMI "/");
	    }
	}
    }
    
    printf(FMI "\" border=0></a></td><td align=left><font face=\"Arial\" size=2 color=white>%s</font></td></tr>\n",$desc);

    @pathfields = split/\//,$album;
    printf(FGI "<html>\n<head><title>%s</title></head>\n<body bgcolor=black fgcolor=white link=white vlink=white>\n<center>\n<table border=0 cellspacing=0 width=80%%>\n<tr><td bgcolor=#111111 align=left><font face=\"Arial\" size=2 color=white>",@pathfields[@pathfields-1]);

    $n = @pathfields-1;
    for ($k = 0; $k < $n; $k++) {
	printf(FGI "<a href=\"");
	for ($kk = ($n - $k); $kk > 0; $kk--) {
	    printf(FGI "../");
        }
	printf(FGI "index.html");
	printf(FGI "\">%s</a> / ",@pathfields[$k]); 
    }

    printf(FGI "%s /</font></td>",@pathfields[@pathfields-1]);
    printf(FGI "</tr>\n</table><table border=0 cellspacing=0 width=80%%>\n<tr>\n");
    $linecounter = 0;
    $photoindex = 0;
    $previousfile = "";
    foreach $picture (@pics) {
	$photoindex++;
	if (!($picture =~ m/_thumb/) && !($picture =~ m/_browse/)) {
	    if ($photoindex < (@pics+0)) {
		$nextfile = "_thumb";
		while (($nextfile =~ m/_thumb/) || ($nextfile =~ m/_browse/)) {
		    $nextfile = @pics[$photoindex];
		    $photoindex++;
		}
		$photoindex--;
		$nextfile =~ s/\.jpg[\r\n]*//gs;
		@pathfields = split/\//,$nextfile;
		$nextfile = @pathfields[@pathfields-1];		
	    }
	    $linecounter++;
	    $filestub = $picture;
	    $filestub =~ s/\.jpg[\r\n]*//gs;

	    $picture =~ s/[\n\r]//gs;
	    $thumb = sprintf("%s_thumb.jpg",$filestub);
	    @error = `convert $picture -scale $thumbsize $thumb`;

	    @pathfields = split/\//,$filestub;
	    $filestubshort = @pathfields[@pathfields-1];

	    if ($nextfile eq $filestubshort) {
		$nextfile = "";
	    }

#           FPP is the "photo page" (root/album/photo.html)
	    open(FPP, ">", sprintf("%s.html",$filestub));
	    printf(FPP "<html>\n<head><title>%s</title></head>\n<body bgcolor=black fgcolor=white link=white vlink=white>\n<center>\n<table border=0  cellspacing=0 width=80%%>\n<tr><td bgcolor=#111111 align=left><font face=\"Arial\" size=2 color=white>",$filestubshort);

            $n = @pathfields-1;
	    for ($k = 0; $k < $n; $k++) {
		printf(FPP "<a href=\"");
		for ($kk = ($n - $k - 1); $kk > 0; $kk--) {
		    printf(FPP "../");
                }
		printf(FPP "index.html");
		printf(FPP "\">%s</a> / ",@pathfields[$k]); 
            }
	    printf(FPP "%s</font></td>",$filestubshort);

	    printf(FPP "<td bgcolor=#111111 align=right><font face=\"Arial\" size=2 color=white>");

	    if ($previousfile ne "") {
		printf(FPP "<a href=\"%s.html\">&lt</a>",$previousfile);
	    } else {
		printf(FPP "&lt");
	    }
	    printf(FPP "&nbsp");
	    if ($nextfile ne "") {
		printf(FPP "<a href=\"%s.html\">&gt</a>",$nextfile);
            } else {
		printf(FPP "&gt");
	    }
            printf(FPP "</font></td></tr>\n</table><table border=0 cellspacing=0 width=80%%>\n<tr>\n");
	    printf(FPP "<td align=center><img src=\"%s.jpg\"></td>\n</tr><tr><td align=center>\n",$filestubshort);

	    printf(FGI "<td width=%s align=center><a href=\"%s.html\"><img src=\"%s_thumb.jpg\" border=0></a>\n<br><br>\n",$width,$filestubshort,$filestubshort);
	    $commentfile = sprintf("%s.txt",$filestub);
	    if (-e $commentfile) {
		$c = `cat $commentfile`;
#		printf(FGI "<font face=\"Arial\" size=2 color=white>%s</font><br><br>\n",$c);
		printf(FPP "<br><br>\n<font face=\"Arial\" size=2 color=white>%s</font>\n",$c);
	    }
	    printf(FPP "</td>\n</tr>\n</table><table border=0 cellspacing=0 width=80%%><tr><td bgcolor=#111111 align=right><font face=\"Arial\" size=2 color=white>generated by trivial gallery v1.0.0</font></td></tr>\n</table>\n</center>\n</body>\n</html>\n");
	    close(FPP);

	    printf(FGI "</td>\n");
	    if ($linecounter == $columns) {
		$linecounter = 0;
		printf(FGI "<\tr>\n<tr>\n");
	    }
	}
	$previousfile = $filestubshort;
    }
    printf(FGI "</tr>\n</table><table border=0 cellspacing=0 width=80%%><tr><td bgcolor=#111111 align=right><font face=\"Arial\" size=2 color=white>trivial gallery v1.0.0</font></td></tr>\n</table>\n</center>\n</body>\n</html>\n");
    close(FGI);
}
printf(FMI "</table>\n<table border=0 cellspacing=0 width=80%%><tr><td bgcolor=#111111 align=right><font face=\"Arial\" size=2 color=white>generated by trivial gallery v1.0.0</font></td></tr>\n</table>\n</center>\n</body>\n</html>");
close(FMI);
